(function() {

    var QWeb = openerp.web.qweb;
    openerp.widgetInstance = null;
    openerp.PayslipUtility = {};

    openerp.PayslipUtility = openerp.Widget.extend({
        template: 'payslip_add.FaultsWidget',
        row_id_select: undefined,
        workedDays: [],

        /* init */
        init: function (parent) {
            this._super(parent);
        },
        /* Start */
        start: function () {
            var self = this;
            var addFaults = this.$el.find('.add-faults');
            var editFaults = this.$el.find('.edit-faults');
            var refreshFaults = this.$el.find('.refresh-faults');

            // create
            addFaults.click(function() {
                self.fectchAddFaults();
            });
            // Edit/ unlink
            editFaults.click(function() {
                self.fectchUpdateFaults();
            });
            // Update
            refreshFaults.click(function() {
                self.fectchRecomputeSheet();
            })
        },
        /* Actualizar ID */
        updateId: function(id) {
            var self = this;
            self.id = id;
        },
        /* Description: Recargar el Widget */
        reloadLine: function() {
            openerp.parentInstance.reload();
        },
        /* Description: Función para remover el modal */
        removeModal: function() {
            $('.expired-account-modal').remove();
            $('.modal-backdrop').remove();
        },
        /* ---------------------------------------------------------------------
        ** Description: Recalcular faltas de funcionario
        ** -------------------------------------------------------------------*/
        /* Description: Función Inicial para recalcular las faltas*/
        fectchRecomputeSheet: function() {
            var self= this;
            self.$el.find('.refresh-faults').attr("disabled", true);
            self.recomputeSheet().then(function(results) {
                return results;
            }).then(function(){
                self.$el.find('.refresh-faults').removeAttr("disabled");
                self.reloadLine()
            });
         },
        /* Description: Función para recalcular las faltas */
        recomputeSheet: function(){
             var self = this;
             var defer = $.Deferred();
             var recomputePayslip = new openerp.web.Model('hr.payslip');

             recomputePayslip.call('recompute_sheet',[ self.id ],{
                     context: new openerp.web.CompoundContext()
             }).then(function(results) {
                 defer.resolve(results);
             });

             return defer;
         },
        /* ---------------------------------------------------------------------
        ** Description: Crear Faltas
        ** -------------------------------------------------------------------*/
        /* Description: Función Inicial Add Faltas */
        fectchAddFaults: function() {
            var self = this;
            self.showPayslipAddFaults();
        },
        /* Description: Adicionar Faltas (Modal) */
        showPayslipAddFaults: function() {
            var self = this;
            var defer =$.Deferred();
            var results = true;

            var modal = QWeb.render('EiruPayslipAddFaults');
            $('.openerp_webclient_container').after(modal);
            $('.expired-account-modal').modal();
            // Close modal
            $('.expired-account-modal').on('hidden.bs.modal', function (e) {
                results = false;
                defer.resolve(results)
                self.removeModal(e);
            });
            // Add faults
            $('.expired-account-modal').find('.add-faults').click(function(e) {
                var details = $('.expired-account-modal').find('.payslip-details').val();
                var number =  $('.expired-account-modal').find('.payslip-number-days').val();

                if (!details){
                    openerp.web.notification.do_warn("Atención","Definir un motivo de la falta .");
                    $('.expired-account-modal').find('.payslip-details').css('border-color','red');
                    return
                } else {
                    $('.expired-account-modal').find('.payslip-details').css('border-color','#ccc');
                }

                if (number <= 0){
                    openerp.web.notification.do_warn("Atención","Días no trabajado, debe ser mayor que 0.");
                    $('.expired-account-modal').find('.payslip-number-days').css('border-color','red');
                    return
                } else {
                    $('.expired-account-modal').find('.payslip-number-days').css('border-color','#ccc');
                }
                self.joinPayslipFaults(number, details).then(function(results){
                    return results;
                }).then(function(results){
                    self.reloadLine()
                    if (!results)
                        results = false;
                });
                defer.resolve(results);
                self.removeModal(e);
            });

            return defer;
        },
        /* Description: Función para agregar nueva falta y hacer el calculo de faltas en la nomina */
        joinPayslipFaults: function(faultsCount, faultsDescri) {
            var self = this;
            var defer = $.Deferred();
            var payslip = new openerp.web.Model('hr.payslip');

            payslip.call('join_payslip_faults',[
                {
                    id: self.id,
                    faultsDays: faultsCount,
                    faultsDescri: faultsDescri
                }
            ], {
                    context: new openerp.web.CompoundContext()
            }).then(function(results) {
                defer.resolve(results);
            });

            return defer;
        },
        /* ---------------------------------------------------------------------
        ** Description: Editar/Remover Faltas
        ** -------------------------------------------------------------------*/
        /* Description: Funcion  Inicial Modify/Unlink Faltas*/
        fectchUpdateFaults: function() {
            var self = this;

            self.fectchWorkedDays().then(function(workedDays) {
                return workedDays;
            }).then(function(workedDays) {
                self.workedDays = workedDays;
                return self.showPayslipModifyFaults();
            }).then(function(results){
                return self.recomputeSheet();
            }).then(function(){
                return self.reloadLine()
            })
         },
        /* Description : Consultar hr.payslip.worked_days */
        fectchWorkedDays: function() {
            var self = this;
            var defer = $.Deferred();

            var fields = ['id', 'name', 'code','number_of_days', 'number_of_hours', 'payslip_id', 'contract_id'];
            var domain = [['payslip_id', '=', self.id],['code', '=', 'FALTAS']];
            var worker_days = new openerp.web.Model('hr.payslip.worked_days');

            worker_days.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });

            return defer;
         },
        /* Description: */
        showPayslipModifyFaults: function() {
            var self = this;
            var defer =$.Deferred();
            var row_modify = null;
            var results = true;

            var modal = QWeb.render('EiruPayslipModifyFaults',{
                workedDays: self.workedDays
            });

            $('.openerp_webclient_container').after(modal);
            $('.expired-account-modal').modal();

            $('.expired-account-modal').find('.modify-faults').attr("disabled", true);
             /*  Close modal */
            $('.expired-account-modal').on('hidden.bs.modal', function (e) {
                results = true;
                defer.resolve(results)
                self.removeModal(e);
            });
            /* Eliminar */
            var unlink_faults= $('.expired-account-modal').find('.unlink-faults')
            unlink_faults.click(function(e){
                 var unlink_row = parseInt($(e.target).closest('td').closest('tr').children()[0].textContent);
                 $(e.target).closest('td').closest('tr').remove()

                 self.unlink_faults_payslip(unlink_row).then(function(results) {
                    defer.resolve(results);
                 })

             })

            /* Modificar*/
            var contenido = $('.expired-account-modal').find('.table-tbody').find('tr');
            contenido.click(function (e) {
                row_modify = $(e.target);
                if (($(e.target).index() === 3) || ($(e.target).index() === 0))
                    return

                $(contenido).removeClass('table-row-select');
                $(e.target).closest('tr').addClass('table-row-select');

                self.row_id_select = parseInt($(e.target).closest('tr').children()[0].textContent);

                var descrip = $(e.target).closest('tr').children()[1].textContent;
                var worked_days = $(e.target).closest('tr').children()[2].textContent;

                $('.expired-account-modal').find('.payslip-details-modify').val(descrip.trim())
                $('.expired-account-modal').find('.payslip-number-days-modify').val(parseInt(worked_days))
                $('.expired-account-modal').find('.modify-faults').removeAttr("disabled");
            });

            /* Click boton Modificar */
            var modify = $('.expired-account-modal').find('.modify-faults');
            modify.click(function(e){
                var descrip = $('.expired-account-modal').find('.payslip-details-modify').val()
                var number = $('.expired-account-modal').find('.payslip-number-days-modify').val()

                if (!descrip){
                    openerp.web.notification.do_warn("Atención","Definir un motivo de la falta .");
                    $('.expired-account-modal').find('.payslip-details-modify').css('border-color','red');
                    return
                } else {
                    $('.expired-account-modal').find('.payslip-details-modify').css('border-color','#ccc');
                }
                if (number <= 0){
                    openerp.web.notification.do_warn("Atención","Días no trabajado, debe ser mayor que 0.");
                    $('.expired-account-modal').find('.payslip-number-days-modify').css('border-color','red');
                    return
                } else {
                    $('.expired-account-modal').find('.payslip-number-days-modify').css('border-color','#ccc');
                }


                self.write_payslip_worked(self.row_id_select, descrip, number).then(function(results) {
                   defer.resolve(results);
                })

                /* Actualizar en el Grid */
                row_modify.closest('tr').children()[1].textContent = descrip
                row_modify.closest('tr').children()[2].textContent = number

                $('.expired-account-modal').find('.payslip-details-modify').val("")
                $('.expired-account-modal').find('.payslip-number-days-modify').val(0)

                $('.expired-account-modal').find('.modify-faults').attr("disabled", true);
            })

            return defer
         },
        /* Description: Eliminar Falta*/
        unlink_faults_payslip: function(id) {
            var self = this;
            var defer = $.Deferred();

            var worked_days = new openerp.web.Model('hr.payslip');
            worked_days.call('unlink_payslip_worked',
            [
                {
                    id: self.id,
                    worked_id: id
                }
            ],{
                context: new openerp.web.CompoundContext()
            }).then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },
        /* Actualizar worked_days */
        write_payslip_worked: function(id, name, number_of_days) {
            var self = this;
            var defer = $.Deferred();

            var worked_days = new openerp.web.Model('hr.payslip');
            worked_days.call('write_payslip_worked',
            [
                {
                    id: self.id,
                    worked_id: id,
                    name: name,
                    days: number_of_days
                }
            ],{
                context: new openerp.web.CompoundContext()
            }).then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },


    });

    if (openerp.web && openerp.web.FormView) {
        openerp.web.FormView.include({
            load_record: function(record) {
                this._super.apply(this, arguments);

                if (this.model !== 'hr.payslip')
                    return;

                if (this.$el.find('.oe_form_sheet.oe_form_sheet_width').closest('.modal-content.openerp').length !== 0)
                    return;

                openerp.parentInstance = this;

                if (openerp.widgetInstance) {
                    openerp.widgetInstance.updateId(record.id);
                }

                if (this.$el.find('.payslip-add-faults').length !== 0 )
                    return;

                openerp.widgetInstance = new openerp.PayslipUtility(this);

                var elemento = this.$el.find('.oe_notebook_page');
                elemento = elemento.find('.payslip-utility-add-faults');

                openerp.widgetInstance.appendTo(elemento);
                openerp.widgetInstance.updateId(record.id);
            }
        });
    }

})();
